[v2] isar-installer: show progress bar during bmaptool copy process

Message ID 20250310065855.272829-1-kasturi.shekar@siemens.com
State Superseded, archived
Headers show
Series [v2] isar-installer: show progress bar during bmaptool copy process | expand

Commit Message

Kasturi Shekar March 10, 2025, 6:58 a.m. UTC
- Added support for a progress gauge using a named pipe to capture and display
 percentage progress when using `bmaptool`.
- The progress bar is displayed only when the `bmaptool` version is 3.8 or above,
 as versions prior to 3.8 has some issues with `--psplash-pipe` flag.
- For `bmaptool` versions below 3.8, the image copy process continues without a
 progress bar to maintain compatibility.
- The gauge uses `dialog --gauge` to dynamically update the progress based on
 output from the `bmaptool` process.

Signed-off-by: Kasturi Shekar <kasturi.shekar@siemens.com>
---
 .../files/usr/bin/deploy-image-wic.sh         | 44 ++++++++++++++++++-
 1 file changed, 42 insertions(+), 2 deletions(-)

Patch

diff --git a/meta-isar/recipes-installer/deploy-image/files/usr/bin/deploy-image-wic.sh b/meta-isar/recipes-installer/deploy-image/files/usr/bin/deploy-image-wic.sh
index 7f552eee..717ec8c9 100755
--- a/meta-isar/recipes-installer/deploy-image/files/usr/bin/deploy-image-wic.sh
+++ b/meta-isar/recipes-installer/deploy-image/files/usr/bin/deploy-image-wic.sh
@@ -149,8 +149,48 @@  if ! $installer_unattended; then
     clear
 fi
 
-if ! bmaptool copy ${bmap_options} "$installer_image_uri" "${installer_target_dev}"; then
-    exit 1
+# Function to compare version numbers
+version_gt() {
+    if [ "$(printf '%s\n' "$1"X "$2" | sort -V | head -n 1)" != "$1"X ]; then
+        return 0
+    else
+        return 1
+    fi
+}
+
+# Get bmap-tools version using dpkg-query
+bmap_version=$(dpkg-query -W -f='${Version}' bmap-tools | awk -F'[~+-]' '{ print $1 }')
+
+if version_gt "$bmap_version" "3.8"; then
+    # Create a named pipe for progress communication
+    progress_pipe="/tmp/progress"
+    if ! mkfifo "$progress_pipe"; then
+        echo "Error: Failed to create named pipe $progress_pipe"
+        exit 1
+    fi
+
+    # Initialize the dialog gauge and update it dynamically
+    (
+        while true; do
+            if read -r line < "$progress_pipe"; then
+                percentage=$(echo "$line" | awk '{ print $2 }')
+                echo "$percentage"
+            fi
+        done
+    ) | dialog --gauge "Flashing image, please wait..." 10 70 0 &
+
+    # Run bmaptool with psplash updating progress
+    if ! bmaptool -q copy ${bmap_options} --psplash-pipe="$progress_pipe" "$installer_image_uri" "$installer_target_dev"; then
+        exit 1
+    fi
+
+    # Clean up the named pipe after completion
+    rm "$progress_pipe"
+
+else
+    if ! bmaptool copy ${bmap_options} "$installer_image_uri" "$installer_target_dev"; then
+        exit 1
+    fi
 fi
 
 if ! $installer_unattended; then